% szm(L0, L): Az L0-L klnbsglista szmjegykdok nem-res listja
% Msszval: L0 elejrl leelemezhet egy szm, s marad L
szm -->
	szmjegy,
	szmmaradk.

% szmmaradk(L0, L): Az L0-L klnbsglista szmjegykdok listja
szmmaradk -->
	(   szmjegy, szmmaradk 
	;   ""
	).      

% szmjegy(L0, L): L0 - [K|L], ahol K egy szmjegy kdja
szmjegy0 --> "0";"1";"2";"3";"4";"5";"6";"7";"8";"9".

szmjegy -->
	[K],
	{decimlis_jegy_kdja(K)}.  

% K egy szmjegy kdja.
decimlis_jegy_kdja(K) :- K >= 0'0, K =< 0'9.

% szmmaradk2(L0, L): L0-L szmjegykdok MAXIMLIS listja
szmmaradk2 -->
	(   szmjegy -> szmmaradk2
	;   ""
	).

% szm2(L0, L): L0 elejrl leelemezhet egy szm, s marad L
szm2 -->
	szmjegy,
	szmmaradk2.

% Leelemezhet egy Sz rtk nem-res szmjegysorozat
szm(Sz) -->
	szmjegy(J),
	szmmaradk(J, Sz).

% Leelemezhet szmjegyek egy esetleg res listja, amelynek
% az eddig leelemzett Sz0-val egytt vett rtke Sz.
szmmaradk(Sz0, Sz) -->
    szmjegy(J), !,
    {Sz1 is Sz0*10+J},
    szmmaradk(Sz1, Sz).
szmmaradk(Sz0, Sz0) --> [].

% leelemezhet egy J rtk szmjegy.
szmjegy(J) --> [K],
	{decimlis_jegy_kdja(K), J is K-0'0}.
